unit Unit1;
{
                      LASTAC v. 1.2

 The idea was to play with the last accessed property of files.

 In first version, I wrote : "which appears nowhere".
 It's not exact :

 In Windows 9x, you can see this information by right-clicking the
 file and selecting properties.

 A file has a CREATED date and time attribute,
 a MODIFIED date and time attribute and also
 a LAST ACCESSED date attribute  (no time it's seems ?)

 Example   for DELPHI32.EXE  :

 1) 6/6/98  20:12:41   ---> creation  (* last install on my H.D. *)

 2) 19/7/96  02:01:00  ---> modification (* date/time creation by Borland ? *)
           Not exactly. they put this time 2:01 for number of the product !

 3) 6/10/98 (today for me !) ---> last access

 Only the second information is displayed by Explorer.

 CAUTION : some files could have only one or two of these three attributes !

 It could be necessary to sometimes consult this information but ...

 A little more interesting :

 When you scan your hard drive for viruses, a lot of files are accessed,
 sometimes all of them if you choose this option.

 Why not use this particularity to find the date of the last virus detection
 independently of the scanning soft.

 This little utility do the job.

 A lot of peaces of material come from the SWAG (http://www.gdsoft.com/swag)
 and from CHAMI (http://chami.com) or
 James L. Allison INTERNET:71565.303@compuserve.com
 I put all this togather and added some small fonctions.

 This program is freeware and the source is given.
 I hope it could help.

 Bravo to Maxim PERESADA (TORRY) which does a marvellous work for
 the Delphi community


 V. 1.0 first release
 V. 1.1 addition of tests on last created/last modified date
 V. 1.2 Correction of encodate problems on certain computers.


 If you are interested contact me :

                   Jean Claude MEIER
                 17, rue de la Tuilerie
                     57420 FLEURY
                        FRANCE

 or better send an e-mail to :

                    j-c.meier@ac-nancy-metz.fr

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Buttons, ShellApi, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    L_ListBox: TLabel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    Edit1: TEdit;
    BBExec: TBitBtn;
    BBVerif: TBitBtn;
    BBSupp: TBitBtn;
    BBRen: TBitBtn;
    CheckBox1: TCheckBox;
    Bevel1: TBevel;
    Label3: TLabel;
    StatusBar1: TStatusBar;
    Label4: TLabel;
    procedure FileListBox1Click(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure BBExecClick(Sender: TObject);
    procedure BBVerifClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure BBSuppClick(Sender: TObject);
    procedure BBRenClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    Procedure Efface_Labels;
    procedure FileListBox1Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Uses traverse;

Const  demande_confirmation : boolean = true;
       jour_semaine : array[1..7] of string =
      ('Sunday   ',
       'Monday   ',
       'Tuesday  ',
       'Wednesday',
       'Thursday ',
       'Friday   ',
       'Saturday ');

Var liste : TStringList;
    quel_disque : String;


Function Nb_BitsparPixel : LongInt;
begin
  Result := (GetDeviceCaps(Form1.Canvas.Handle, BITSPIXEL) *
     GetDeviceCaps(Form1.Canvas.Handle, PLANES));
end;

Procedure TForm1.Efface_Labels;
begin
  label1.caption := '';
  label2.caption := '';
  label3.caption := '';
end;

// from CHAMI and Jon Erik Oterhals and modified
function DT_Fichier(nom_fic : string; quelle_date : byte) : string;
var
  FileHandle : THandle;
  LocalFileTime : TFileTime;
  DosFileTime : DWORD;
  The_Time : TDateTime;
  FindData : TWin32FindData;
begin
  FileHandle := FindFirstFile(PChar(nom_fic), FindData);
  if FileHandle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(FileHandle);
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
    begin
      case quelle_date of
        0 : FileTimeToLocalFileTime(FindData.ftCreationTime, LocalFileTime);
        1 : FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
        2 : FileTimeToLocalFileTime(FindData.ftLastAccessTime, LocalFileTime);
      end;
      try
        FileTimeToDosDateTime(LocalFileTime,
        LongRec(DosFileTime).Hi,LongRec(DosFileTime).Lo);
        The_time := FileDateToDateTime(DosFileTime);
        result := DateTimeToStr(The_Time);
      except
        On EConvertError do result := '';
      end;
    end;
  end;
end;

procedure Execute_Fichier(Chemin : string);
begin
  ShellExecute(0, Nil, PChar(Chemin), Nil, Nil, SW_NORMAL );
end;

procedure TForm1.FileListBox1Click(Sender: TObject);

Function Date_Fichier (le_label : string ; no : byte) : string;
Var chaine : string;
begin
  try
    chaine := DT_Fichier(FileListBox1.FileName,no);
    chaine := le_label +
    jour_semaine[DayOfWeek(StrToDateTime(chaine))] + ' ' + chaine;
  Except
   chaine := le_label+'Unknown';
  End;
  result := chaine;
end;

begin
  Efface_Labels;
  label1.caption := Date_Fichier(' Created       : ',0);
  label2.caption := Date_Fichier(' Modified      : ',1);
  label3.caption := Date_Fichier(' Last accessed : ',2);
end;

procedure TForm1.DriveComboBox1Change(Sender: TObject);
begin
  Efface_Labels;
end;

procedure TForm1.BBExecClick(Sender: TObject);
begin
   Execute_Fichier(FileListBox1.FileName);
end;
// on met toutes les dates dans une liste
function Ajoute(Path: string; Info: tSearchRec): Action;
begin
  if (Info.name <> '.') and  (Info.name <> '..') then
  begin
    Liste.Add(DT_Fichier(Path+'\'+Info.name,2));
    Application.ProcessMessages;
    Form1.StatusBar1.SimpleText := Path+'\'+Info.name;
  end;
  Ajoute := FindMore;
end;

// on compte pour chaque date rencontre, le nombre de fois qu'elle apparat.
// Celle qui domine est celle de la dernire vrification (right ?????)
procedure Cherche_Date;
Var i,j : integer;
    nb_fois: integer;
    ch_date, ch_provisoire : string;
begin
  Liste.Sort;
  ch_date := Liste.Strings[0];
  nb_fois := 1;
  i := 0;
  while Liste.count > 0  do
  begin
    ch_provisoire := Liste.Strings[0];
    while  (i < Liste.count) and (Liste.Strings[i] = ch_provisoire) do
    inc(i);
    if i > nb_fois then
    begin
       nb_fois := i;
       ch_date := ch_provisoire;
    end;
    for j :=  i-1 downto 0 do Liste.delete(j);
    i := 0;
  end;
  Form1.StatusBar1.SimpleText := '';
  MessageDlg('The date of your last virus detection,'#13#10+
             ' on disk '+Quel_Disque[1]+', is probably :'#13#10#13#10+
  '      '+jour_semaine[DayOfWeek(StrToDate(ch_date))]+' '+
  ch_date,mtWarning,[mbOk],0);
end;
// Cherche la date la plus frquemment rencontre
procedure TForm1.BBVerifClick(Sender: TObject);
begin
  Efface_Labels;
  Quel_Disque := DirectoryListBox1.directory;
  Quel_Disque := Copy(Quel_disque,1,3);
  if ((Quel_Disque[1] ='A') or (Quel_Disque[1] = 'B')) then
  begin
    MessageDlg('Go on a hard drive !',mtError,[mbok],0);
    exit;
  end;
  try
    Liste := TStringList.create;
    Screen.Cursor := crHourglass;
    Walk_tree(Quel_Disque,faVolumeID+faDirectory,true,Ajoute);
    Cherche_Date;
  finally
    Liste.free;
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  BBExec.enabled := edit1.text <> '*.*';
  BBSupp.enabled := edit1.text <> '*.*';
  BBRen.enabled  := edit1.text <> '*.*';
  CheckBox1.enabled := edit1.text <> '*.*';
end;

procedure TForm1.BBSuppClick(Sender: TObject);
begin
  Case demande_confirmation of
    false  : begin
               DeleteFile(FileListBox1.FileName);
               FileListBox1.Update;
               Efface_Labels;
             end;
    true :  if MessageDlg('Do you really want to delete : '+FileListBox1.FileName,
             mtConfirmation,mbOKCancel,0) = mrOK then
             begin
               DeleteFile(FileListBox1.FileName);
               FileListBox1.Update;
               Efface_Labels;
             end;
  end;

end;

procedure TForm1.BBRenClick(Sender: TObject);
Var clickok : boolean;
    nom_fic, chaine : string;
begin
  chaine := '';
  nom_fic := FileListBox1.FileName;
  ClickOK := InputQuery('New name of '+ExtractFileName(nom_fic),
  'Verify (name[.ext]) and confirm', chaine);
  If Pos('.',Chaine) = 0 then chaine := chaine+ExtractFileExt(nom_fic);
  if ClickOK then
  begin
    renamefile(nom_fic,ExtractFilePath(nom_fic)+chaine);
    FileListBox1.Update;
    Efface_Labels;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  demande_confirmation := checkbox1.checked;
  if demande_confirmation then
  begin
    CheckBox1.color := clAqua;
    BBSupp.Hint := 'after confirmation'
  end
  else
  begin
    CheckBox1.color := clRed;
    BBSupp.Hint := 'WITHOUT CONFIRMATION !!!';
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BBSupp.Hint := 'after confirmation';
  If Nb_BitsparPixel > 8 then       // > 256 couleurs
  begin    // pour faire plus joli 
    Color := RGB(197,197,226);
    L_ListBox.Transparent := true;
    DriveComboBox1.Color := RGB(210,255,210);
    DirectoryListBox1.Color := RGB(210,255,210);
    FileListBox1.Color := RGB(210,255,210);
    Edit1.Color := RGB(210,255,210);
  end;  
end;

procedure TForm1.FormActivate(Sender: TObject);
Var   disque_courant : string;
begin
  GetDir(0,disque_courant);
  disque_courant:= copy(disque_courant,1,3);
  DirectoryListBox1.directory := disque_courant;
  Label4.Caption := 'Date on your computer : '+Datetostr(Now);
end;

procedure TForm1.FileListBox1Change(Sender: TObject);
begin
  if FileListBox1.Items.Count > 0
  then FileListBox1.Hint := 'Click on a file'
  else FileListBox1.Hint := 'Click on a folder';
end;

end.


